<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2009 Tim Lochmueller <webmaster@fruit-lab.de>
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/


/**
 * Automator base class for handle this extension
 *
 * @author	Tim Lochmueller <webmaster@fruit-lab.de>
 * @package	TYPO3
 */
class tx_automator {
	
	
	/**
	 * Generate the backend selector box
	 * 
	 * @param	array/reference		An reference of the backend selector box array
	 * @param	array/reference		An reference of the backend selector box object
	 */
	public function getBeSelectSteps(&$items, &$obj){
		
		// Create registry
		require_once(t3lib_extMgm::extPath('automator').'classes/class.tx_automator_Registry.php');
		$register = t3lib_div::makeInstance('tx_automator_Registry');
		
		// Move the registerd function to the backend (orderd by category)
		$steps = $register->getSteps();
		foreach($steps as $category => $elements) {
			foreach($elements as $ele) {
				$items['items'][] = array($GLOBALS['LANG']->getLL('category.'.$category).$category.': '.$ele['name'], $ele['selectKey']);
			}	
		}
	}
	
	
	/**
	 * Register a step
	 * 
	 * @see tx_automator_Registry::registerStep
	 */
	static public function registerStep($name, $location, $category = 'ext'){
		require_once(t3lib_extMgm::extPath('automator').'classes/class.tx_automator_Registry.php');
		$register = t3lib_div::makeInstance('tx_automator_Registry');
		return $register->registerStep($name, $location, $category);
	}
	
	
	/**
	 * Auto registry for all steps in the automator extension
	 * parse the step structure and sort them in the defined categories
	 */
	static public function autoRegisterAutomator(){
		$automator = t3lib_div::makeInstance('tx_automator');
		$files = array();
		$path = t3lib_extMgm::extPath('automator').'steps/';
		t3lib_div::getAllFilesAndFoldersInPath(&$files, $path, 'php');
		foreach($files as $file) {
			$check = str_replace($path, '', $file);
			$parts = explode('/', $check);
			$name = str_replace(array('class.', '.php'), '', $parts[1]);
			$automator->registerStep($name, $file.'->'.$name, $parts[0]);
		}
	}
	

} # class - tx_automator

if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/automator/classes/class.tx_automator.php'])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/automator/classes/class.tx_automator.php']);
} # if
?>