<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2010 Tim Lochmueller <webmaster@fruit-lab.de>
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/


/**
 * Automator ajax functionality
 *
 * @author	Tim Lochmueller <webmaster@fruit-lab.de>
 * @package	TYPO3
 */
class tx_automator_Ajax {

	
	/**
	 * Base function for the backend process bar to execute auotmatoer scripts
	 */
	public function runAction(){
		
		// require the automator engine
		require_once(t3lib_extMgm::extPath('automator').'classes/class.tx_automator_Runner.php');
		$runner = t3lib_div::makeInstance('tx_automator_Runner');
		
		// Init an action
		$actionID = trim(t3lib_div::_GET('actionID'));
		if($actionID > 0 && t3lib_div::testInt($actionID)) {
			$runID = $runner->startAction($actionID);
			if(!$runID) return 'Error: System get no valid runID.';
			$stepID = 0;
		} # if
		
		// Init runID
		$runID = isset($runID)?$runID:t3lib_div::_GET('runID');
		if(trim($runID) == '') return 'Error: No valid runID given as parameter.';

		
		// Start the Automator step
		$runner->start($runID);
			
		// Percent
		$percent = floor($runner->getCurrentStepNumber()/$runner->getNumberOfAllSteps()*100);
		echo '<html><head>
		<link rel="stylesheet" type="text/css" href="'.t3lib_extMgm::extRelPath('automator').'toolbarmenu/tx_automator.css" media="" />
		</head>
		<body id="loading">
			<span id="status" style="width: '.$percent.'%">&nbsp;</span>
			<p id="info">'.$runner->storageData['meta']['title'].' [ID: '.$runner->storageData['meta']['uid'].']: Step '.$runner->getCurrentStepNumber().'/'.$runner->getNumberOfAllSteps().' - '.$percent.'%</p>';
		
		
		$runner->setDelay(500);
		
		if($runner->getCurrentStepNumber() == $runner->getNumberOfAllSteps()) {
			echo '<script type="text/javascript">
			window.setTimeout(function(){ top.TYPO3AutomatorBackend.finishAction(); }, 5000);
			</script>';
		} else {
			echo $runner->getJsStep($_GET['stepID']);
		}
		$runner->finish();
		echo '</body></html>';
		
		
		
	}
	
	
} # class - tx_automator_Registry

if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/automator/classes/class.tx_automator_Ajax.php'])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/automator/classes/class.tx_automator_Ajax.php']);
} # if
?>