/***************************************************************
*  Copyright notice
*
*  (c) 2009 Tim Lochmueller <webmater@fruit-lab.de>
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*  A copy is found in the textfile GPL.txt and important notices to the license
*  from the author is found in LICENSE.txt distributed with these scripts.
*
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

var AutomatorBackend = Class.create({

	/**
	 * registers for resize event listener and executes on DOM ready
	 */
	initialize: function() {
		Event.observe(window, 'resize', this.positionMenu);

		Event.observe(window, 'load', function(){
			this.positionMenu();
			this.toolbarItemIcon = $$('#tx-automator-menu .toolbar-item img')[0].src;

			Event.observe('tx-automator-menu', 'click', this.toggleMenu);

		}.bindAsEventListener(this));
	},

	/**
	 * positions the menu below the toolbar icon, let's do some math!
	 */
	positionMenu: function() {
		var calculatedOffset = 0;
		var parentWidth      = $('tx-automator-menu').getWidth();
		var ownWidth         = $$('#tx-automator-menu ul')[0].getWidth();
		var parentSiblings   = $('tx-automator-menu').previousSiblings();
		parentSiblings.each(function(toolbarItem) {
			calculatedOffset += toolbarItem.getWidth() - 1;
			if(toolbarItem.down().hasClassName('no-separator')) {
				calculatedOffset -= 1;
			}
		});
		calculatedOffset = calculatedOffset - ownWidth - ownWidth + parentWidth +1;

		$$('#tx-automator-menu ul')[0].setStyle({
			left: calculatedOffset+'px'
		});
	},

	/**
	 * toggles the visibility of the menu and places it under the toolbar icon
	 */
	toggleMenu: function(event) {
		var toolbarItem = $$('#tx-automator-menu > a')[0];
		var menu        = $$('#tx-automator-menu .toolbar-item-menu')[0];
		toolbarItem.blur();

		if(!toolbarItem.hasClassName('toolbar-item-active')) {
			toolbarItem.addClassName('toolbar-item-active');
			Effect.Appear(menu, {duration: 0.2});
			TYPO3BackendToolbarManager.hideOthers(toolbarItem);
		} else {
			toolbarItem.removeClassName('toolbar-item-active');
			Effect.Fade(menu, {duration: 0.1});
		}

		if(event && (Event.element(event).hasClassName('toolbar-item') || Event.element(event).up().hasClassName('toolbar-item'))) {
			Event.stop(event);
		}
	},
	
	
	startAction: function(number){
		$('tx_automator_menu_runner').setStyle({display: 'block'});
		window.open("ajax.php?ajaxID=tx_automator_Ajax::runAction&actionID="+number, "tx_automator_runAction");
	},
	
	
	finishAction: function(){
		$('tx_automator_menu_runner').setStyle({display: 'none'});
		window.open("ajax.php?ajaxID=tx_automator_Ajax::runAction", "tx_automator_runAction");
	}

});

var TYPO3AutomatorBackend = new AutomatorBackend();


